Map To Poster – Create Art of your favourite city
296 points
2 months ago
| 26 comments
| github.com
| HN
stanko
2 months ago
[-]
There is a related project which I used several times:

https://github.com/anvaka/city-roads

Edit: it outputs SVGs and you can try it online. Anvaka (author) has other really cool dataviz projects.

reply
sandos
2 months ago
[-]
Kinda sad that maptoposter uses png. SVG is so much better in this case, if you want to actually print a poster!
reply
PetahNZ
2 months ago
[-]
It does support SVG, --format=svg
reply
Helmut10001
2 months ago
[-]
San Francisco looks nice, but there seems to be a problem with the projection in some of the sample images. It looks as if it isn't UTM but a global sphere projection, which isn't suitable for local renders. It's suspicious that the word 'projection' isn't mentioned in the Readme.
reply
jasongill
2 months ago
[-]
This is an artistic project to make a fun and artsy poster, so it's not at all "suspicious" that the map projection is not critical to the artwork.

It also appears to be open source, so perhaps you can open a pull request with your improvements based on your cartographical experience.

reply
Helmut10001
2 months ago
[-]
You are absolutely correct. Suspicious was the wrong word and I did not mean to criticize the author or the work.
reply
jlarocco
2 months ago
[-]
It looks like the final images have some kind of vignetting to make the corners and outter edges fade away. Probably grabbing OSM tiles and doing some image processing.

Looks neat!

reply
mvdwoord
2 months ago
[-]
Great project! It takes a bit of fiddling to get the distance parameter right in some cases, and two possible improvements would be to allow for coordinate input rather than city name so I can point it at a specific spot as the center of the map. Another one would be to output all styles simultaneously so I can visually select from the generated images.

Anyhow, nice work. Thanks!

reply
hyperific
2 months ago
[-]
Also check out prettymapp

https://prettymapp.streamlit.app/

reply
croisillon
2 months ago
[-]
reply
mft_
2 months ago
[-]
I believe (from a quick code check on my phone) it should be possible to output the images to SVG with a little tweak, thanks to your use of matplotlib?

Is there a reason you’ve defaulted to PNG that I’m missing?

reply
originalankur
2 months ago
[-]
Valid Point @mft_ plt.savefig(output_file, format='svg', facecolor=THEME['bg']) should do it. I will add a --format parameter and make the change.
reply
Footprint0521
2 months ago
[-]
Holy heck exporting to PDF/SVG for large cities is laggy, just patched the repo and did it for one over half a million people and it’s insanely slow lol
reply
originalankur
2 months ago
[-]
There is throttling in the code when making api request to respect the map provider as per their terms and conditions. Can make few thing parallel but it's a hobby project how many posters would one person want to generate?.
reply
nycerrrrrrrrrr
2 months ago
[-]
Does anyone have recommendations for how to actually print a poster from images like these?
reply
fmajid
2 months ago
[-]
El-co Color in New Jersey is known for its affordable 20x30" poster prints.

https://www.elcocolor.net/index.php/poster-special

reply
jfengel
2 months ago
[-]
For what it's worth, I use Vistaprint. That's not based on an extensive comparison, just that it always works for me and seems comparable in price and quality to other services.
reply
loloquwowndueo
2 months ago
[-]
For something DIY, Rasterbator.net can make you a poster-sized print in multiple sheets. You’ll need some elbow grease to assemble the print.
reply
xnx
2 months ago
[-]
In the US, I've had good results with Staples
reply
1970-01-01
2 months ago
[-]
I remember one of these had a service that made a 3D relief map (3D print) and then framed it, so you could hang it onto a wall.
reply
dexterdog
2 months ago
[-]
dotphoto.com
reply
hirako2000
2 months ago
[-]
A good print on demand that delivers ?
reply
stephenlf
2 months ago
[-]
This repo is fantastic. The README should be the gold standard for OSS. Not to mention how stunning the outputs are. Thanks for sharing.
reply
nl
2 months ago
[-]
This really needs to be `uvx` runnable.
reply
tianqi
2 months ago
[-]
That's splendid. I've long wanted to make a jigsaw puzzle out of Sydney's road map, so I can familiarise myself with the layout of roads while having fun. That way I can reduce my reliance on nav app and become one of those old-school drivers.
reply
bobnamob
2 months ago
[-]
There's a reason Where 2 -> Google Maps happened in Sydney. The sheer number of one-way roads combined with the imposition of the harbour and the messy tunnel system make internalising Sydney navigation a life-long endeavour
reply
dylan604
2 months ago
[-]
What happens if there are multiple cities with the same name. Maybe this is a US specific problem, but there are many states with cities of the same name from another state. As a few examples:

Salem, OR and Salem, MA

Portland, OR and Portland, ME

Springfield, IL and Springfield, MO

Dallas, TX and Dallas, GA

reply
MengerSponge
2 months ago
[-]
Don't even get started on American cities named after world cities: Paris, Munster, London, Toledo, Memphis, Athens,...
reply
tokai
2 months ago
[-]
Every country has those. There was some that found it very funny when Russia occupied New York last year (or last year again?).
reply
netsharc
2 months ago
[-]
Even the name "New York" is a reference to an existing city...
reply
MengerSponge
2 months ago
[-]
But they had the decency to append "New". New Birmingham? New Athens? New Madrid? These are cyberpunk city names.
reply
ornornor
2 months ago
[-]
There is a Suisse in France, but no France in Switzerland afaik
reply
fat_cantor
2 months ago
[-]
If you just type "Salem" for the city, it just picks one and goes with it. If you type "Salem, Oregon" vs "Salem, MA", it gives the desired result (at least for the cases I've tried), and then uses your input text as the caption.
reply
vivzkestrel
2 months ago
[-]
there is also a salem in tamil nadu india
reply
originalankur
2 months ago
[-]
lol, I didn't even think of it. May be I should start taking country too. Edge case :-p
reply
tomashubelbauer
2 months ago
[-]
Three random themes for anyone who's Czech or likes Prague and doesn't want to set up the script locally: https://imgur.com/a/Ovg8mDW
reply
originalankur
2 months ago
[-]
Looks beautiful. The gold+dark color does justice.
reply
xixixao
2 months ago
[-]
What’s up with the Zizkovska tower highlight?
reply
emaro
2 months ago
[-]
I tried it in a python3 venv, but the download data step is stuck at 0% unfortunately.
reply
NoboruWataya
2 months ago
[-]
The bar only updates once that entire step is complete (ie, if step 1 of 3 is downloading roads, it won't tell you what % of roads have been downloaded, but rather it will remain at 0% until all roads are downloaded at which point it will jump to 33%).
reply
emaro
2 months ago
[-]
Thank you, it worked with the help of your tips!
reply
originalankur
2 months ago
[-]
It will work, give it time. Also default distance is 29000. Give distance of 10000 to see faster results. It certainly is working as many users have generated maps.
reply
originalankur
2 months ago
[-]
Also note that as per their terms and conditions I need to give a user agent, so multiple users will be sharing same user agent right now.
reply
m-hodges
2 months ago
[-]
Etsy sellers devastated
reply
kingforaday
2 months ago
[-]
Awesome! After I generate, where can I take that super res image and get a high quality photo print to frame?
reply
giarc
2 months ago
[-]
Really depends on country you live in. Just google local printers and email them.
reply
simonebrunozzi
2 months ago
[-]
The map of Venice seems to be the only one whose image is "squeezed" horizontally. Wondering why.
reply
originalankur
2 months ago
[-]
need to take into consideration the length and width of the city and choose distance appropriately. I haven't followed my own suggestion here - https://github.com/originalankur/maptoposter?tab=readme-ov-f... will fix.
reply
hehe23
2 months ago
[-]
Hi! I generated a map as well, but indeed, the map is squeezed horizontally. I have here a screenshot from a map and the poster: https://photos.diffop.be/apps/photos/public/h6JKMJImLZCXutcT...

I have tried adjusting -d, but it only affects the scale.

Here is the command I used: python create_map_poster.py --city Leuven --country Belgium --distance 4000 --theme sunset

reply
Yash16
2 months ago
[-]
Are you using a coding package or graph-based approach for this, or is it standard image generation? I’ve seen very similar results on https://picxstudio.com —it’s an AI image generation platform.
reply
mindwork
2 months ago
[-]
https://maptoposter.penk.in/

Using Claude Code and OP's library, I've put it on the internets. Web hosting is cheap(free) and generation takes some time

reply
giarc
2 months ago
[-]
I get an ambiguous error when submitting a request.

Error: Generation failed: ==================================================

reply
mindwork
2 months ago
[-]
yup, something to fix in the future. I suspect it couldn't find city coordinates
reply
Kwpolska
2 months ago
[-]
Pretty cool! It would be great if there was a way to set coordinates manually, since Nominatim can sometimes produce mediocre results. Also, would be nice to have a way to render the same map in all themes, not just one.
reply
originalankur
2 months ago
[-]
The initial version were coordinates actually but then realised people mostly love their cities more than anything and it's easy that way. Will add this feature back as optional parameters.
reply
colinbartlett
2 months ago
[-]
These demonstrate just how car-obsessed our society is. Depressing.
reply
japoneris
2 months ago
[-]
Looks amazing ! In my free time, i play with my laser cutting machine. It will save me some design time. Thanks
reply
doophus
2 months ago
[-]
Why are big chunks of Sam Francisco missing (eg around the bridge) missing from the example?
reply
Sajarin
2 months ago
[-]
Those smooth chunks are all (mostly) public park land. Known as Presidio and part of the Golden Gate National Recreation Area.
reply
originalankur
2 months ago
[-]
You know your city.
reply
originalankur
2 months ago
[-]
python create_map_poster.py -c "San Francisco" -C "USA" -t sunset -d 10000

-d should be approx. 10k to 14k given the size of the city. You can give it a shot.

reply
cinntaile
2 months ago
[-]
It says there are examples but I can't see them?
reply
originalankur
2 months ago
[-]
Please check on desktop, the table is hiding images in responsive mode - You can see the images on X here https://x.com/getpy/status/2009255303775174684
reply
cinntaile
2 months ago
[-]
Thanks, I didn't notice there was another column that I could sidescroll to!
reply
arnavpraneet
2 months ago
[-]
what are the blue dots? (not water bodies i think?)
reply
Footprint0521
2 months ago
[-]
I was curious about this too and it’s actually a bug— these blue dots are random parks or park features. Most parks are polygons, but less than 5% or them are points from volunteer mappers who didn’t make them polygons and so these stray points seem to slip through and get plotted as the matplotlib default color…

If only I knew this before I printed it out and attached it all together with rasterbator lol

reply
thamer
2 months ago
[-]
Yes, the blue and orange dots are from the water and parks Nodes and Ways in the OSM data.

It doesn't look like the orange and blue colors are part of the theme definitions, so the rendering library may be using some default values. This is why they are rendered in the same color on images using different theme files.

reply
7777777phil
2 months ago
[-]
Very cool, thanks for sharing!!
reply
vivzkestrel
2 months ago
[-]
- for those of you that dont want to install this locally, run this inside docker

*`Dockerfile`*

``` FROM python:3.12.10-slim-bookworm

RUN apt-get update -q -y && apt-get install -q -y \ build-essential \ git \ python3-dev \ && rm -rf /var/lib/apt/lists/*

RUN groupadd --gid 10000 python \ && useradd --uid 10000 --gid python --shell /bin/bash --create-home python

WORKDIR /home/python/app

RUN git clone https://github.com/originalankur/maptoposter.git

RUN chown -R python:python ./maptoposter

# 5. Switch to non-root user USER python

RUN pip install --no-cache-dir --upgrade pip && \ cd ./maptoposter && \ pip install --no-cache-dir -r requirements.txt

CMD ["sleep", "infinity"]

```

*`main.sh`*

``` #!/usr/bin/env bash

# https://github.com/originalankur/maptoposter # Read the documentation to change themes and settings for each city

# Get the directory where THIS script is located SCRIPT_DIR=$(cd -- "$(dirname -- "${BASH_SOURCE[0]}")" &> /dev/null && pwd) cd "$SCRIPT_DIR" || exit 1

# TODO: kolkata is done already, change to some other city both here and on that notepad.pw link in Chrome readonly CITY="kolkata" readonly COUNTRY="india"

readonly CONTAINER_NAME="map_to_poster"

if ! docker buildx build \ --file "Dockerfile" \ --progress none \ --tag "${CONTAINER_NAME}" \ --quiet .; then printf "Error: %s" "while attempting to build the docker container:${CONTAINER_NAME}" exit 1 fi

if ! docker container run \ --detach \ --interactive \ --name "${CONTAINER_NAME}" \ --tty \ "${CONTAINER_NAME}"; then printf "Error: %s" "while attempting to run the docker container:${CONTAINER_NAME}" exit 1 fi

container_id=$(docker ps -aqf "name=${CONTAINER_NAME}")

if [ -z "$container_id" ]; then echo "Container not found!" else echo "The ID for ${CONTAINER_NAME} is: $container_id" fi

docker exec -i "${CONTAINER_NAME}" /bin/bash << EOF cd /home/python/app/maptoposter python create_map_poster.py --city "${CITY}" --country "${COUNTRY}" EOF

mkdir -p "${HOME}/map_to_poster"

if ! docker cp "${container_id}":/home/python/app/maptoposter/posters "${HOME}/map_to_poster"; then printf "Error: %s" "while attempting to copy map files from container:${CONTAINER_NAME}" fi

if ! docker stop "${CONTAINER_NAME}"; then printf "Error: %s" "stopping container:${CONTAINER_NAME}" fi

if ! docker rm "${CONTAINER_NAME}"; then printf "Error: %s" "removing container:${CONTAINER_NAME}" fi

```

reply
giuliomagnifico
2 months ago
[-]
Nice! Thanks
reply